package winMain;

#
# winMain.pm
#
# [mkcorpus] The main-window
#

#-------
# Export

use Exporter;
use vars qw(@ISA @EXPORT  $mw $start_dir $new_num_doc $b_menu $nom_fic $max_num_doc $num_doc $winNb $info $saisie $saisie2 $saisie3 $search_string $replace_string $cpt_file_balises $texte $mkTextXpath $levelxmlConverter1  $indxmlConverter1  $headxmlConverter1 $levelxmlConverter2 $indxmlConverter2  $headxmlConverter2 $levelxmlConverter3 $indxmlConverter3  $headxmlConverter3  $mainXmlviewer2  $listePn2SelectionMarkup  $listePn2SelectionMarkup2  $search_string_map $listePn2  $listePn2Map $position_search $waitBoxWidget @courant %Courant @liste_xmlBalise %Liste_xmlBalise @liste_xmlLexicoBalise %Liste_xmlLexicoBalise @liste_xmlLexicoBalise2 %Liste_xmlLexicoBalise2 %listeBaliseXmlLexico %compteurBaliseXmlLexico %compteurBaliseXml %listeBaliseXml %mapTextFull @mapText $imageSelectFile $imageSearch $imageLoad $imageExit $imageHelp $imageSave $imageScan $imageSelect $imageText $imageReplace $imageDelete $imageClearSearch $imageNoHighlight $logoMKC $winBalloon $pctComplete $progressText $splash 

);
@ISA = qw(Exporter);
@EXPORT = qw(&CreateWinMain 
$mw
$start_dir $new_num_doc $nom_fic $max_num_doc $num_doc $b_menu  $winNb $info $saisie $saisie2 $saisie3 $search_string $replace_string $cpt_file_balises $texte  $mkTextXpath $levelxmlConverter1  $indxmlConverter1  $headxmlConverter1 $levelxmlConverter2 $indxmlConverter2  $headxmlConverter2 $levelxmlConverter3 $indxmlConverter3  $headxmlConverter3  $mainXmlviewer2  $listePn2SelectionMarkup  $listePn2SelectionMarkup2  $search_string_map $listePn2  $listePn2Map $position_search $waitBoxWidget @courant %Courant @liste_xmlBalise %Liste_xmlBalise @liste_xmlLexicoBalise %Liste_xmlLexicoBalise @liste_xmlLexicoBalise2 %Liste_xmlLexicoBalise2 %listeBaliseXmlLexico %compteurBaliseXmlLexico %compteurBaliseXml %listeBaliseXml %mapTextFull @mapText $imageSelectFile $imageSearch $imageLoad $imageExit $imageHelp $imageSave $imageScan $imageSelect $imageText $imageReplace $imageDelete $imageClearSearch $imageNoHighlight $logoMKC $winBalloon 
);

#-------
# packages

use Getopt::Long;
use English;
use File::Basename;
use File::Find;
use Cwd;
use strict; 
use Getopt::Std;
use Text::Wrap; 

use Tk;
use Tk::Text;
use Tk::Balloon;
use Tk::ObjScanner;
use Tk::DirTree;
use Tk::WaitBox;
use Tk::ProgressBar;
use Tk::TextUndo;
use Tk::Date;
use Tk::XMLViewer;
use Tk::Animation;
use Tk::Dialog;
use Tk::DialogBox;
use Tk::Toplevel;
use Tk::FileSelect;


use XML::Parser;
use XML::Parser::Grove;
use XML::Grove;
use XML::Grove::Visitor;
use XML::Grove::Iter;
use XML::XPath;
use XML::DOM;
use XML::EasyOBJ;

#use Net::FTP;

use LWP::UserAgent;
use HTML::Parser;
use HTML::FormatText;
use HTML::FormatPS;
use LWP::Simple;
use HTML::LinkExtor;
use URI::URL;

use winFunc;

use mkCorpusModules::SubHandlers;
use mkCorpusModules::EliInfo;
use mkCorpusModules::MyVisitor;
use mkCorpusModules::DirSelect;

#-----------------
# Global variables
# Accessable from outside

$mw;
$start_dir;
$new_num_doc;
$nom_fic;
$max_num_doc;
$num_doc;
$winNb;
$b_menu;
$info;
$saisie; 
$saisie2; 
$saisie3;
$search_string;
$replace_string; 
$cpt_file_balises;
$texte ;
$mkTextXpath;
$levelxmlConverter1 ;
$indxmlConverter1 ;
$headxmlConverter1;
$levelxmlConverter2; 
$indxmlConverter2 ;
$headxmlConverter2;
$levelxmlConverter3; 
$indxmlConverter3 ;
$headxmlConverter3;
$mainXmlviewer2 ;
$listePn2SelectionMarkup ;
$listePn2SelectionMarkup2 ;
$search_string_map;
$listePn2 ;
$listePn2Map;
$position_search;
$waitBoxWidget;

#------------------
#Tableaux

@courant;
%Courant;
@liste_xmlBalise;
%Liste_xmlBalise;
@liste_xmlLexicoBalise;
%Liste_xmlLexicoBalise;
@liste_xmlLexicoBalise2;
%Liste_xmlLexicoBalise2;
%listeBaliseXmlLexico;
%compteurBaliseXmlLexico;
%compteurBaliseXml;
%listeBaliseXml;
%mapTextFull;
@mapText;

$imageSelectFile;
$imageSearch;
$imageLoad;
$imageExit;
$imageHelp;
$imageSave;
$imageScan;
$imageSelect;
$imageText;
$imageReplace;
$imageDelete;
$imageClearSearch;
$imageNoHighlight;
$logoMKC;
$pctComplete;
#$progress;
$progressText;
$splash;

$winBalloon;

#------------------
# Private Variables

my $img;
my $progress;
my $toolsTypweb;
my $helpTypweb;
my $typweb036;
my $typweb038;
my $alceste;
my $cordial;
my $lexico;
my $mirroringSite;
my $typwebParseRegExp;
my $typwebParseXML;
my $prepHtml;
my $statCorpus;
my $fileCorpus;
my $menuxmlconverters;
my $menuhtmlconverters;
my $menuhtmltidy;
my $menuxmlTidy;
my $menuxmladdtag;
my $menuxmlViewer;
my $menuxmlParser;
my $menuxmlXpath;
my $menuxmlGrove;
my $menuxmlParseDTD;
my $menuxmlExtractor;
my $menuxmlElement;
my $menuxmlInProgress;
my $nlpregexp;
my $nlpsuffix;
my $nlpconcordance;
my $nlpbigram1;
my $nlpbigram2;
my $nlpothers;
my $time;

my $a_menu;
my $c_menu;
my $c0_menu;
my $d_menu;
my $d0_menu;
my $d1_menu;
my $d2_menu;
my $d3_menu;
my $e_menu;
my $f_menu;
my $g_menu;
my $h_menu;
my $help_menu;
my $browser_menu;

my $corpusview;
my $checkchar;

my $buttonOpen;
my $buttonLoad;
my $buttonSelect;
my $buttonExit;
my $buttonHelp;
my $buttonSave;
my $buttonText;
my $buttonScan;
my $cadre;
my $cadre1;
my $cadre11;
my $cadre2;
my $cadreTop;
my $w_string;
my $w_string_label;
my $w_string_label1;
my $w_string_label2;
my $w_string_label3;
my $w_string_entry;
my $w_string_entry1;
my $w_string_entry3;
my $w_string_entry2;
my $w_string_button;
my $w_string_button1;
my $w_string_button2;
my $w_string_button3;
my $w_string2;
my $w_string2_label;
my $w_string2_button;
my $w_string2_entry;
my $Filename;

#--------------------
# CreateWinMain()
#
# Creates the main-window

sub CreateWinMain()
{
$mw= MainWindow->new;
$mw->title("CorpusPlusBuilder \@(Tal Paris 3 - CLA2T) v.1.01");
$mw->withdraw;

#------------------
$splash = $mw->Toplevel(-title => "mkCorpus is coming soon..." , -visual => 'truecolor');
## Make the application exit if the splash window is closed...
$splash->protocol( 'WM_DELETE_WINDOW' => sub {exit} ) ;

my $img = $splash->Photo(-file=> 'pics/logo.xpm');
$splash->Label( -image => $img)->pack;
## Progress bar on splash screen...
$pctComplete = 0;
$progress = $splash->ProgressBar(-variable => \$pctComplete,
   -borderwidth => 7, -relief => 'flat', -width => 20, -length => 300,
	-padx => 0, -pady => 0,-gap => 0,
	-from => 0, -to => 100,
   -colors => [0 => 'green', 50 => 'yellow' , 80 => 'red'],
   -troughcolor => 'white',
)->pack;

$progressText = "";
$splash->Label( -textvariable => \$progressText )->pack;

#------------------
 

$new_num_doc=0;
$nom_fic="Nouveau".$new_num_doc.".txt";
$max_num_doc=10;
$num_doc=0;
@courant=();
%Courant=();
$start_dir = &GetCWD;
$winNb=0;
 
#---------------------------------------------------------------------------------------
#Image Boutons
$imageSelectFile = $mw->Photo(-file => "icons/file_open.xpm");
$logoMKC = $mw->Photo(-file => "pics/logo.xpm");
$imageSearch = $mw->Photo(-file => "icons/search.xpm");
$imageLoad = $mw->Photo(-file => "icons/open.xpm");
$imageExit = $mw->Photo(-file => "icons/small.exit.xpm");
$imageHelp = $mw->Photo(-file => "icons/small.help_3d.xpm");
$imageSave = $mw->Photo(-file => "icons/filesave.xpm");
$imageScan = $mw->Photo(-file => "icons/scan.xpm");
$imageSelect=$mw->Photo(-file => "icons/small.select_3d.xpm");
$imageText=$mw->Photo(-file => "icons/filenew.xpm");
$imageReplace=$mw->Photo(-file => "icons/small.icon_copy_3d.xpm");
$imageDelete=$mw->Photo(-file => "icons/cut.xpm");
$imageClearSearch=$mw->Photo(-file => "icons/small.no_entry_3d.xpm");
$imageNoHighlight=$mw->Photo(-file => "icons/refresh.xpm");


#---------------------------------------------------------------------------------------
#Variable pas utilise correctement
$cpt_file_balises=0;


#---------------------------------------------------------------------------------------
$winBalloon = $mw->Balloon(
      -initwait => 400,
      -state    => 'balloon'
   );
#---------------------------------------------------------------------------------------
splashProgress( "Initialising first bit... Main Window Definition", 5 );
sleep 1;

#---------------------------------------------------------------------------------------
$texte= $mw->Scrolled("TextUndo")->pack(-side => 'bottom',
			      -fill => 'both',
	    		      -expand => 1);
$texte->Text(-setgrid => 'true');

$mw->protocol('WM_DELETE_WINDOW'=>  sub{ConfirmExit2($texte);});
# my $scanner = $mw->ObjScanner( caller => $texte, title=>"windows") -> pack ;

#---------------------------------------------------------------------------------------
$cadreTop = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');

my $date = $cadreTop->Date(-editable => 0,
		     -variable => \$time,
		     -value => 'now',
		    )->pack(-side => 'left');

$date->repeat(999, sub { $time = time(); });

my $running;
my $camel=$mw->Animation('-format' => 'gif',
			   -file => Tk->findINC('anim.gif'));
my $l = $cadreTop->Label(-image => $camel)->pack(-side => 'right');
$cadreTop->Button(-text => 'Start/Stop',
	     -command => sub {
		 if (!$running) {
		     $camel->start_animation(80);
		 } else {
		     $camel->stop_animation();
		 }
		 $running = !$running;
	     })->pack(-side => 'right');

#---------------------------------------------------------------------------------------
$cadre = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');
#---------------------------------------------------------------------------------------
splashProgress( "Initialising first bit... Menu File Definition", 5 );
sleep 1;

$b_menu=$cadre->Menubutton(-text => "File",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "~View dir",
					  -command => \&open_dir],
                                          ['command' => "~View AND Select dir",
					  -command => \&viewAndSelectDir],
					  ['command' => "~Select File & open",
					  -command => \&query_file_dialog],
					  ['command' => "~Select File & not open",
					  -command => \&query_file_dialog3],
					  ['command' => "Open this file",
					  -command => \&lire_fic],
				          ['command' => "~Save this file",
					  -command => \&sauve_fic],
				          ['command' => "~Save this file as",
					  -command => \&query_file_dialog2],
					  ['command' =>"~Clear", 
					  -command => sub{ConfirmEmptyDocument2($texte);}],
				          ['command' => "Exit",
					   -command =>    sub{ConfirmExit2($texte);}
					  ]])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
splashProgress( "Initialising first bit... Menu Edit Definition", 5 );
sleep 1;


$c0_menu=$cadre->Menubutton(-text => "Edit",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems =>
			   [
    ["command"=>'Undo', -command => [$texte => 'undo']],
    ["command"=>'Redo', -command => [$texte => 'redo']],
     "-",@{$texte->EditMenuItems}
  ])->pack(-side => 'left');


#---------------------------------------------------------------------------------------
splashProgress( "Initialising first bit... Menu Search Definition", 5 );
sleep 1;

$c_menu=$cadre->Menubutton(-text => "Search",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "I-Search",
					-command => \&i_search],
				       ['command' => "Repeat I-Search",
					-command => \&i_search2],
				       ['command' => "Global Search",
					-command => \&search_in_fic],
				       ['command' => "I-Replace",
					-command => \&i_replace],
				       ['command' => "Repeat I-Replace",
					-command => \&i_replace2],
				       ['command' => "Global Replace",
					-command => \&replace],
				       ['command' => "Search-Replace in Multiple Files",
			                -command => \&tksm]
					  ])->pack(-side => 'left');

$mw->bind("<Button-3>",sub{ $c_menu->Popup(-popover => 'cursor',
						    _popanchor => "nw")});

#---------------------------------------------------------------------------------------
splashProgress( "Initialising first bit... Menu Markup Definition", 5 );
sleep 1;

$d0_menu=$cadre->Menubutton(-text => "Markup <[^>]+>",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "View all",
					-command => \&list_balise],
				       ['command' => "Delete all",
					-command => \&del_balise],
				       ['command' => "Search all",
					-command => \&search_balise],
				       ['command' => "I-Search",
					-command => \&i_search],
				       ['command' => "Repeat I-Search",
					-command => \&i_search2],
				       ['command' => "Extract Text in Markups",
					-command => \&query_search_text_in_balise]
					  ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
splashProgress( "Initialising first bit... Menu HTML Definition", 5 );
sleep 1;

$d1_menu=$cadre->Menubutton(-text => "Tools HTML",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
					  ["cascade" => "HTML-Converter"],
					  ["cascade" => "HTML-TIDY"]
					  ])->pack(-side => 'left');
$menuhtmlconverters =$d1_menu->menu->Menu(-menuitems => [
							 ['command' => "Html2Text (special)",
							  -command => \&html0],
							 ['command' => "Html2Text",
							  -command => \&html1],
							 ['command' => "Html2PostScript",
							  -command => \&html2],
							 ['command' => "rtf2html",
							  -command => \&rtf2html],
							 ['command' => "rtf2xml",
							  -command => \&rtf2xml],
							 ['command' => "ps2html",
							  -command => \&ps2html],
							 ['command' => "txt2html",
							  -command => \&txt2html],
							 ['command' => "perl2html",
							  -command => \&perl2html]
							 ]);
$menuhtmltidy =$d1_menu->menu->Menu(-menuitems => [
						   ['command' => "Clean HTML with Tidy (Win32)",
						    -command => \&query_dir_tidyClean1],
						   ['command' => "Clean HTML with Tidy HELP",
						    -command => \&help_tidyClean1]
						   ]);

$d1_menu->entryconfigure("HTML-Converter",-menu =>$menuhtmlconverters);
$d1_menu->entryconfigure("HTML-TIDY",-menu =>$menuhtmltidy);

#---------------------------------------------------------------------------------------
splashProgress( "Initialising first bit... Menu XML Definition", 5 );
sleep 1;

$d2_menu=$cadre->Menubutton(-text => "Tools XML",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
					  ["cascade" => "XML-Viewer"],
					  ["cascade" => "XML-Parser"],
					  ["cascade" => "XML XPath"],
					  ["cascade" => "XML-Grove"],
					  ["cascade" => "XML-ParseDTD"],
				          ["cascade" => "XML-Extractor"],
				          ["cascade" => "XML-Element"],
				          ["cascade" => "XML-AddTagInTextNode"],
					  ["cascade" => "XML-TIDY"],
					  ["cascade" => "XML-Converters"],
					  ["cascade" => "XML-In-Progress"]
					  ])->pack(-side => 'left');

$menuxmlViewer =$d2_menu->menu->Menu(-menuitems => [
				       ['command' => "XML as Tree",
					-command => \&eventXML],
                                       ['command' => "XML Viewver (1)",
					-command => \&xmlViewver],
                                       ['command' => "XML Viewver (2)",
					-command => \&xmlViewver_2]
						]);
$menuxmlParser = $d2_menu->menu->Menu(-menuitems => [
				       ['command' => "Parse File",
					-command => \&parseXML]]);
$menuxmlExtractor = $d2_menu->menu->Menu(-menuitems => [
				       ['command' => "Select Markup (Handlers)",
					-command => \&xmlMkListBalise],
				       ['command' => "Select Markup (1) (DOM)",
					-command => \&xmlDomExtractTag],
				       ['command' => "Select Markup (2) (DOM)",
					-command => \&xmlDomExtractTag1],
					['command' => "Extract Markup with Search_string (DOM)",
					-command => \&xmlDomExtractTagWithSearchString],
							]);
$menuxmlElement = $d2_menu->menu->Menu(-menuitems => [
				       ['command' => "XML Comment",
					-command => \&xmlComment],
				       ['command' => "XML Stat",
					-command => \&xmlStat],
				       ['command' => "Print Elt As Text (with DOM)",
					-command => \&printEltAsTextWithDOM],
				       ['command' => "Print Text Elt (with DOM)",
					-command => \&printTextEltWithDOM],
				       ['command' => "Rename TAG",
					-command => \&renameTAGXML],
				       ['command' => "Add ID on TAG",
					-command => \&addIDOnTAG]
						      ]);
$menuxmladdtag = $d2_menu->menu->Menu(-menuitems => [
				       ['command' => "Add TAG in Text NODE",
					-command => \&addTagInTextNode],
				       ['command' => "I-Add TAG in Text NODE",
					-command => \&iaddTagInTextNode],
				       ['command' => "Help Add TAG in Text NODE",
					-command => \&helpaddTagInTextNode]
						      ]);
$menuxmlParseDTD = $d2_menu->menu->Menu(-menuitems => [
				       ['command' => "Parse DTD",
					-command => \&parseDTD]]);
$menuxmlInProgress = $d2_menu->menu->Menu(-menuitems => [
				       ['command' => "REX/XML",
					-command => \&xmlRex]]);
$menuxmlGrove = $d2_menu->menu->Menu(-menuitems => [
				       ['command' => "xmlGrove 1",
					-command => \&xmlGroveTool1]]);
$menuxmlXpath = $d2_menu->menu->Menu(-menuitems => [
				       ['command' => "Extract node via Xpath",
					-command => \&xmlXpath],
				       ['command' => "Extract all nodes with text via Xpath",
					-command => \&xmlXpath2],
				       ['command' => "Extract all selected nodes (by name)",
					-command => \&xmlXpath3],
				       ['command' => "Interface Xpath (Win32)",
					-command => \&xmlXpath4],
				       ['command' => "Help Xpath",
					-command => \&help_xmlXpath]
						    ]);

$menuxmlTidy = $d2_menu->menu->Menu(-menuitems => [
						   ['command' => "HTML2XML with Tidy (Win32)",
						    -command => \&query_dir_tidyClean],
						   ['command' => "HTML2XML with Tidy HELP",
						    -command => \&help_tidyClean]
						   ]);

$menuxmlconverters = $d2_menu->menu->Menu(-menuitems => [
							 ['command' => "XML2html",
							  -command => \&xmlConverter1],
							 ['command' => "XML2pod",
							  -command => \&xmlConverter2],
							 ['command' => "XML2txt",
							  -command => \&xmlConverter3],
						   ]);


$d2_menu->entryconfigure("XML-Viewer",-menu =>$menuxmlViewer);
$d2_menu->entryconfigure("XML-Parser",-menu =>$menuxmlParser);
$d2_menu->entryconfigure("XML XPath",-menu =>$menuxmlXpath);
$d2_menu->entryconfigure("XML-Grove",-menu =>$menuxmlGrove);
$d2_menu->entryconfigure("XML-ParseDTD",-menu =>$menuxmlParseDTD);
$d2_menu->entryconfigure("XML-Extractor",-menu =>$menuxmlExtractor);
$d2_menu->entryconfigure("XML-Element",-menu =>$menuxmlElement);
$d2_menu->entryconfigure("XML-AddTagInTextNode",-menu =>$menuxmladdtag);
$d2_menu->entryconfigure("XML-TIDY",-menu =>$menuxmlTidy);
$d2_menu->entryconfigure("XML-Converters",-menu =>$menuxmlconverters);
$d2_menu->entryconfigure("XML-In-Progress",-menu =>$menuxmlInProgress);
					 
#---------------------------------------------------------------------------------------
splashProgress( "Initialising first bit... Menu SGML Definition", 5 );
sleep 1;

$d3_menu=$cadre->Menubutton(-text => "Tools SGML",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [['command' => "item 1",
					-command => \&sgml1],
				       ['command' => "item2",
					-command => \&sgml2]
					  ])->pack(-side => 'left');
#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit , Menu Map definition...", 25 );
sleep 1;
#---------------------------------------------------------------------------------------
$h_menu=$cadre->Menubutton(-text => "Map-Corpus",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
					  ['command' => "Make TAG-Map (RegExp)",
					   -command => \&makeTextToMap],
					  ['command' => "Make TAG-Map (DOM)",
					   -command => \&maketagmap],
					  ['command' => "Make TREE-TAG-Map (DOM)",
					   -command => \&maketreetagmap]
					  ])->pack(-side => 'left')  ;

#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit, Menu Corpus Definition...", 25 );
sleep 1;
#---------------------------------------------------------------------------------------
$e_menu=$cadre->Menubutton(-text => "Corpus Tools",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
					  ["cascade" => "StatTools"],
					  ["cascade" => "FileTools"],
					  ["cascade" => "CheckChar"],
					  ["cascade" => "PrepHTML2Txt"],
					  ["cascade" => "Lexico"],
				          ["cascade" => "Alceste"],
				          ["cascade" => "Cordial"]]
			   )->pack(-side => 'left');
$statCorpus=$e_menu->menu->Menu(-menuitems => [
                                           ['command' => "Stat File",
					    -command => \&statFile]
                                            ]);
$fileCorpus=$e_menu->menu->Menu(-menuitems => [
                                           ['command' => "Concat File (for Lexico)",
					    -command => \&concatFile2lexico],
					       ['command' => "Concat File (-> XML)",
					    -command => \&concatFile2xml],
					       ['command' => "HELP Concat File",
					    -command => \&help_concatFile]
                                            ]);
$checkchar=$e_menu->menu->Menu(-menuitems => [
                                           ['command' => "Read Char",
					    -command => \&readCharInText],
				           ['command' => "Change Char",
					    -command => \&changeCharInText],
				           ['command' => "Change Ascii",
					    -command => \&changeAsciiInText],
				           ['command' => "Change UnrocognizedChar",
					    -command => \&changeUnrocognizedCharInText],
                                            ['command' => "Apply Change in TableCharacter (No Log)",
					    -command => \&applyChangeInTableCharacter1],
				           ['command' => "Apply Change in TableCharacter (Log)",
					    -command => \&applyChangeInTableCharacter2]
                                            ]);
$prepHtml=$e_menu->menu->Menu(-menuitems => [['command' => "Read One Dir",
					    -command => \&query_dir_prepOneDir],
				           ['command' => "Read One File",
					    -command => \&mkPrepHtml2txtOneFile]
                                            ]);

$lexico=$e_menu->menu->Menu(-menuitems => [['command' => "Extract Selected Markup For Lexico-Corpus (Handlers-1)",
					    -command => \&lexico1],
                                           ['command' => "Extract Selected Markup For Lexico-Corpus (Handlers-2)",
					    -command => \&lexico2],
				           ['command' => "Extract Selected Markup For Lexico-Corpus (DOM)",
					    -command => \&lexico3],
				           ['command' => "HELP Maj->Min",
					    -command => \&help_lexico4],
				           ['command' => "Change Maj->Min",
					    -command => \&lexico4],
				           ['command' => "HELP Specif-Sort",
					    -command => \&help_lexico5],
				           ['command' => "Specif-Sort",
					    -command => \&lexico5],
				           ['command' => "HELP DSR-Sort",
					    -command => \&help_lexico6],
				           ['command' => "DSR-Sort",
					    -command => \&lexico6]
                                           ]);
$alceste=$e_menu->menu->Menu(-menuitems => [['command' => "Make Corpus",
					    -command => \&alceste1],
				           ['command' => "Verify Corpus",
					    -command => \&alceste2]]);
$cordial=$e_menu->menu->Menu(-menuitems => [['command' => "help Make Corpus",
					    -command => \&help_cordial],
					    ['command' => "Make Corpus-Tag",
					    -command => \&cordial],
					    ['command' => "Cordial 2 Lexico v.1",
					    -command => \&cordial2Lexico],
					    ['command' => "Cordial 2 Lexico v.2",
					    -command => \&cordial2Lexico2],
					    ['command' => "Cordial 2 XML ",
					    -command => \&cordial2xml],
					    ['command' => "Help Cordial 2 XML ",
					    -command => \&help_cordial2xml]
					    ]);
$e_menu->entryconfigure("StatTools",-menu =>$statCorpus);
$e_menu->entryconfigure("FileTools",-menu =>$fileCorpus);
$e_menu->entryconfigure("CheckChar",-menu =>$checkchar);
$e_menu->entryconfigure("PrepHTML2Txt",-menu =>$prepHtml);
$e_menu->entryconfigure("Lexico",-menu =>$lexico);
$e_menu->entryconfigure("Alceste",-menu =>$alceste);
$e_menu->entryconfigure("Cordial",-menu =>$cordial);
#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit, Menu NLP definition...", 25 );
sleep 1;
#---------------------------------------------------------------------------------------
$g_menu=$cadre->Menubutton(-text => "NLP Tools",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
					  ["cascade" => "Count-regExp"],
					  ["cascade" => "Suffix-Prefix"],
					  ["cascade" => "Concordance"],
					  ["cascade" => "Bigram-word"],
					  ["cascade" => "Bigram-char"],
				          ["cascade" => "Others"]
					  ]
			   )->pack(-side => 'left');
#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit (NLPa)...", 25 );
sleep 1;

$nlpregexp=$g_menu->menu->Menu(-menuitems => [
					      ['command' => "FindTypes",
					       -command => \&findTypes],
					      ['command' => "Extract Region",
					       -command => \&extractRegion],
					      ['command' => "WordCount",
					       -command => \&mkWordCount]
					   ]);

$nlpsuffix=$g_menu->menu->Menu(-menuitems => [
                                           ['command' => "WebFix",
					    -command => \&webfix],
					   ['command' => "Help Webfix",
					    -command => \&helpwebfix]
					   ]);
#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit (NLPb)...", 25 );
sleep 1;

$nlpothers=$g_menu->menu->Menu(-menuitems => [
					      ['command' => "xWords (Dict)",
					       -command => \&mkXWord]
					      ]);
#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit (NLPc)...", 25 );
sleep 1;


$nlpconcordance=$g_menu->menu->Menu(-menuitems => [
						   ['command' => "Concordance (one word) 1",
						    -command => \&mkConcordanceOneWord],
						   ['command' => "Concordance (one word) 2",
						    -command => \&mkConcordanceOneWord2],
						   ['command' => "Concordance (all word) 1",
						    -command => \&mkConcordance],
						   ['command' => "Concordance (all word) 2",
						    -command => \&concordanceFormat],
						   ['command' => "Collocate",
						    -command => \&mkCollocate]
						   ]);
#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit (NLPd)...", 25 );
sleep 1;

$nlpbigram1=$g_menu->menu->Menu(-menuitems => [
					       ['command' => "Bigram (Word)",
						-command => \&mkBigramWord],
					       ['command' => "Trigram (Word)",
						-command => \&mkTrigramWord],
					       ['command' => "FourGram (Word)",
						-command => \&mkFourgramWord]
					      ]);
#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit (NLPe)...", 25 );
sleep 1;

$nlpbigram2=$g_menu->menu->Menu(-menuitems => [
					       ['command' => "help Bigram Char",
						-command => \&help_bigramChar],
					       ['command' => "1-Make-index",
						-command => \&makeIndex],
					       ['command' => "2-Mots2BigramUniques",
						-command => \&mots2BigramUniques],
					       ['command' => "3-BigrammesUniques2Distance",
						-command => \&bigrammesUniques2Distance],
					       ['command' => "4-mots2Distance_unix",
						-command => \&mots2Distance]
					       ]
					       );
#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit (NLPf)...", 50 );
sleep 1;

$g_menu->entryconfigure("Count-regExp",-menu =>$nlpregexp);
$g_menu->entryconfigure("Suffix-Prefix",-menu =>$nlpsuffix);
$g_menu->entryconfigure("Concordance",-menu =>$nlpconcordance);
$g_menu->entryconfigure("Bigram-word",-menu =>$nlpbigram1);
$g_menu->entryconfigure("Bigram-char",-menu =>$nlpbigram2);
$g_menu->entryconfigure("Others",-menu =>$nlpothers);

#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit, Menu Typweb Definition...", 25 );
sleep 1;
#---------------------------------------------------------------------------------------
$f_menu=$cadre->Menubutton(-text => "Typweb",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
					  ["cascade" => "DownloadSite"],
					  ["cascade" => "Typweb036"],
					  ["cascade" => "Typweb038"],
				          ["cascade" => "Tools"],
				          ["cascade" => "HELPs"]
					  ])->pack(-side => 'left');

$mirroringSite=$f_menu->menu->Menu(-menuitems => [
						  ['command' => "Page Mirror",
						   -command => \&query_loadPageMirroring],
						  ['command' => "Site Mirror",
						   -command => \&query_loadMirroring],
						  ['command' => "Wget",
						   -command => \&query_wget],
						  ['command' => "Site UpLoad",
						   -command => \&query_uploading]
						  ]);

$typweb036=$f_menu->menu->Menu(-menuitems => [['command' => "webxref-Read One Local Web Dir (036)",
					    -command => \&webxref1],
				           ['command' => "webxref-Read Index File (036)",
					    -command => \&webxref2],
					      ['command' => "mktipo-Read WebXref Results Site (036)",
					    -command => \&mktipo1],
					      ['command' => "extandstat-Make stat (036)",
					    -command => \&makestat1],
					      ['command' => "Tag HTML (036)",
					    -command => \&typwebExtractTagHTML],
						   ['command' => "Select Markup (036)",
					    -command => \&mkSelectionMarkup]
					    ]);
$typweb038=$f_menu->menu->Menu(-menuitems => [
					      ['command' => "webxref-Read One Local Web Dir (038)",
					       -command => \&webxref11],
					      ['command' => "webxref-Read One Dir of Local Web Dir (038)",
					       -command => \&webxrefOneDir],				          
					      ['command' => "webxref-Read Index File (038)",
					       -command => \&webxref22],
					      ['command' => "webxref-Read One Local Web Dir (038 Unix Lynx)",
					       -command => \&webxref11Lynx],
					      ['command' => "webxref-Read One Dir of Local Web Dir (038 Unix Lynx)",
					       -command => \&webxrefOneDirLynx],			          
					      ['command' => "webxref-Read Index File (038 Unix Lynx)",
					       -command => \&webxref22Lynx],
					      ['command' => "webxref-Read Local Web Dir (038-homolWin32)",
					       -command => \&webxref111],
					      ['command' => "webxref-Read Index File (038-homolWin32)",
					       -command => \&webxref222],
					      ['command' => "webxref-Read Local Web Dir (038-homolUnix Lynx)",
					       -command => \&webxref1111],
					      ['command' => "webxref-Read Index File (038-homolUnix Lynx)",
					       -command => \&webxref2222],
					      ['command' => "Make StatWordByFile-Matrice (038 Unix-Lynx)",
					       -command => \&makeMatrice],
					      ['command' => "Make \"Text Only\" (038 Unix-Lynx)",
					       -command => \&makeMatrice2],
					      ['command' => "Make LINKS Matrice (038)",
					       -command => \&makeMatriceLinks],
					      ['command' => "Make TAG Corpus For Lexico (038)",
					       -command => \&makeCorpusTAG]
					    ]);


$toolsTypweb=$f_menu->menu->Menu(-menuitems => [['command' => "Extract TxtBrut",
						 -command => \&typwebExtractTxtBrut],
						['command' => "Select Markup",
						 -command => \&typwebMkListBalise],
						['command' => "DECANTEUR (\@2001 Grouin)",
						 -command => \&decanteur],
						['command' => "MAKE XML CORPUS TYPWEB",
						 -command => \&makeXMLCorpusTypweb]


						]);


$helpTypweb=$f_menu->menu->Menu(-menuitems => [
					      ['command' => "HELP WEBXREF",
					       -command => \&helpwebxref],
					       ['command' => "HELP Make TAG-WORD Matrice",
					       -command => \&helpmakeMatrice],
					       ['command' => "HELP Make Matrice Links",
					       -command => \&helpmakeMatriceLinks],
					       ['command' => "HELP Make TAG Corpus",
					       -command => \&helpmakeCorpusTAG],
					      ['command' => "HELP TOOLS TYPWEB",
					       -command => \&helptypweb]

						]);


$f_menu->entryconfigure("DownloadSite",-menu =>$mirroringSite);
$f_menu->entryconfigure("Typweb036",-menu =>$typweb036);
$f_menu->entryconfigure("Typweb038",-menu =>$typweb038);
$f_menu->entryconfigure("Tools",-menu =>$toolsTypweb);
$f_menu->entryconfigure("HELPs",-menu =>$helpTypweb);
#---------------------------------------------------------------------------------------
splashProgress( "Initialising second bit, Menu HELP...", 25 );
sleep 1;

#---------------------------------------------------------------------------------------
$help_menu=$cadre->Menubutton(-text => "Help",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
					  ['command' => "Package Help",
					-command => \&helpPackage],
					  ['command' => "Package Help with Pod",
					-command => \&helpPod2txt],
                                          ['command' => "MkCorpus Help",
					-command => \&command_help]
					  ])->pack(-side => 'left');

#---------------------------------------------------------------------------------------
$browser_menu=$cadre->Menubutton(-text => "Browser",
			   -tearoff => 0,
			   -relief => 'ridge',
			   -menuitems => [
					  ['command' => "Browser Help MKC",
					-command => \&browser1],
                                          ['command' => "Browser",
					-command => \&browser2]
					  ])->pack(-side => 'left');


#---------------------------------------------------------------------------------------
splashProgress( "Initialising third bit (dum-de-dum)...", 80 );
sleep 1;
#---------------------------------------------------------------------------------------
$cadre1 = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');
$search_string = '';
$w_string = $cadre1->Frame()->pack(-side => 'top', -fill => 'x');
$buttonOpen=$w_string->Button(-text => "Select File",
                -image => $imageSelectFile,
	     -command => sub {&query_file_dialog})->pack(-side => 'left',
						   -anchor => 'e');
$winBalloon->attach($buttonOpen,
                  -balloonmsg => "Select File"
               );
$w_string_button1 = $w_string->Button(-text => 'No Highlight', -image => $imageNoHighlight);
$winBalloon->attach($w_string_button1,
                  -balloonmsg => "Stop HighLight"
               );
$w_string_button1->pack(-side => 'left', -pady => 5, -padx => 10);
$w_string_label = $w_string->Label(-text => 'Search string:', -width => 13, -anchor => 'w');
$saisie2= $w_string_entry = $w_string->Entry(-textvariable => \$search_string);
$w_string_label2 = $w_string->Label(-text => 'Delete string:', -width => 13, -anchor => 'w');
$w_string_entry2 = $w_string->Entry( -textvariable => \$search_string);
$w_string_button = $w_string->Button(-text => 'Highlight', -image => $imageSearch);
$winBalloon->attach($w_string_button,
                  -balloonmsg => "Search and Highlight"
               );
$w_string_button1 = $w_string->Button(-text => 'No Highlight', -image => $imageNoHighlight);
$winBalloon->attach($w_string_button1,
                  -balloonmsg => "Stop HighLight"
               );
$w_string_button2 = $w_string->Button(-text => 'Delete', -image => $imageDelete);
$winBalloon->attach($w_string_button2,
                  -balloonmsg => "Delete"
               );
$w_string_button3 = $w_string->Button(-text => 'ClearSearch', -image => $imageClearSearch);
$winBalloon->attach($w_string_button3,
                  -balloonmsg => "Clear Search"
               );
$w_string_label->pack(-side => 'left');
$w_string_entry->pack(-side => 'left');
$w_string_label2->pack(-side => 'left');
$w_string_entry2->pack(-side => 'left');
$w_string_button->pack(-side => 'left', -pady => 5, -padx => 10);
$w_string_button2->pack(-side => 'left', -pady => 5, -padx => 10);
$w_string_button3->pack(-side => 'left', -pady => 5, -padx => 10);
$w_string->pack(-side => 'top', -fill => 'x');
$w_string_button->configure(-command => [sub {&text_search($texte, $search_string, 'search')}, $texte]);
$w_string_button1->configure(-command => [sub {&remove_mark_search}]);
$w_string_button2->configure(-command => [sub {&text_delete($texte, $search_string, 'search')}, $texte]);
$w_string_button3->configure(-command => [sub {&remove_search}]);
$w_string_entry->bind('<Return>' => [sub {shift; &text_search($texte, $search_string, 'search')}, $texte]);
$w_string_entry2->bind('<Return>' => [sub {shift; &text_delete($texte, $search_string, 'search')}, $texte]);
$w_string->pack(-side => 'top', -fill => 'x');
if ($mw->depth > 1) {
	text_toggle($texte, ['configure', 'search', -background => 'SeaGreen4', -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      } else {
	text_toggle($texte, ['configure', 'search', -background => 'black',     -foreground => 'white'], 800,
		          ['configure', 'search', -background => undef,       -foreground => undef],   200);
      }

$saisie2->delete(0,'end');
#---------------------------------------------------------------------------------------
splashProgress( "Oops, more to do than expected...One more bit maybe!", 60 );
sleep 1;
#---------------------------------------------------------------------------------------
$cadre11 = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');
$w_string2 = $cadre11->Frame()->pack(-side => 'top', -fill => 'x');
$w_string2_label = $w_string2->Label(-text => 'Replace with string:', -width => 20, -anchor => 'w');
$saisie3= $w_string2_entry = $w_string2->Entry(-textvariable => \$replace_string);
$w_string2_button = $w_string2->Button(-text => 'Replace', -image => $imageReplace);
$winBalloon->attach($w_string2_button,
                  -balloonmsg => "Replace String"
               );
$w_string2_label->pack(-side => 'left');
$w_string2_entry->pack(-side => 'left');
$w_string2_button->pack(-side => 'left', -pady => 5, -padx => 10);
#$w_string2->pack(-side => 'top', -fill => 'x');
$w_string2_button->configure(-command => [sub {&text_replace($texte, $search_string, $replace_string, 'search')}, $texte]);
$w_string2_entry->bind('<Return>' => [sub {shift; &text_replace($texte, $search_string, $replace_string, 'search')}, $texte]);
$w_string2->pack(-side => 'top', -fill => 'x');
$saisie3->delete(0,'end');
#---------------------------------------------------------------------------------------
$cadre2 = $mw->Frame->pack(-side => 'top',
			  -fill => 'x');
$cadre2->Label(-text => "File : ",
    	      -relief => 'raised')->pack(-side => 'left',
						  -anchor => 'w');
$saisie=$cadre2->Entry(-textvariable => \$nom_fic)->pack(-side => 'left',
						-anchor => 'w',
						-fill => 'x',
						-expand => 1);
#$saisie->delete(0,'end');
#$saisie->insert('end',"Nouveau");
$Filename=$texte->FileName($nom_fic);
#$filename = $texte->FileName;
#print "$Filename\n";
$buttonLoad=$cadre2->Button(-text => "Load",
                -image => $imageLoad,
	       -command => sub {&lire_fic})->pack(-side => 'left',
						   -anchor => 'e');
$winBalloon->attach($buttonLoad,
                  -balloonmsg => "Load File"
               );
$buttonSelect=$cadre2->Button(-text => "Select Markup",
                -image => $imageSelect,
	       -command => sub {&mkSelectionMarkup})->pack(-side => 'left',
						   -anchor => 'e');
$winBalloon->attach($buttonSelect,
                  -balloonmsg => "Select Markup"
               );
$buttonExit=$cadre2->Button(-text => "Exit",
                            -image => $imageExit,
	       -command => sub{ConfirmExit2($texte)})->pack(-side => 'right');
$winBalloon->attach($buttonExit,
                  -balloonmsg => "Exit"
               );
$buttonHelp=$cadre2->Button(-text => "Help",
                -image => $imageHelp,
	       -command => sub {&command_help})->pack(-side => 'right',
						   -anchor => 'e');
$winBalloon->attach($buttonHelp,
                  -balloonmsg => "Help"
               );
#	$Mbut_help = $mbar->Menubutton(relief => 'raised', 
#		text => "help",
#		underline => 0);
#	$Mbut_help->pack(-side => 'right');
#	$Mbut_help->command(-label => 'help', -command => \&command_help);

#---------------------------------------------------------------------------------------
splashProgress( "Initialising last bit. Nearly there...", 99 );
sleep 1;
#---------------------------------------------------------------------------------------


$buttonSave=$cadre2->Button(-text => "Save",
                -image => $imageSave,
	       -command => sub {&sauve_fic})->pack(-side => 'right',
						   -anchor => 'e');
$winBalloon->attach($buttonSave,
                  -balloonmsg => "Save This file"
               );
$buttonText=$cadre2->Button(-text => "New",
            -image => $imageText,
	    -command => sub{ConfirmEmptyDocument2($texte);})->pack(-side => 'right',
						  -anchor => 'e');
$winBalloon->attach($buttonText,
                  -balloonmsg => "New file"
               );
$buttonScan=$cadre2->Button(-text => "Scan",
            -image => $imageScan,
	    -command => sub{&scanner;})->pack(-side => 'right',
						  -anchor => 'e');
$winBalloon->attach($buttonScan,
                  -balloonmsg => "Scan Objets"
               );
#---------------------------------------------------------------------------------------
$mw->Label(-textvariable => \$info,
	   -relief => 'ridge')->pack(-side => 'bottom',
				     -fill => 'x');
#---------------------------------------------------------------------------------------

## Remove splash and pop main window to top...
$splash->destroy;
$mw->deiconify;
$mw->raise;


MainLoop;

}

1;
