#!/usr/local/bin/perl
# decanteur.pl

<<DOC;
Cyril Grouin - 15/05/01

          decanteur.pl

En chimie, un dcanteur est un appareil qui transvase doucement un liquide qui a dpos pour en sparer les impurets ou le fond. Au sens figur, il s'agit d'un appareil qui sert  clarifier.
Ce script permet d'extraire automatiquement les donnes personnelles inclues dans des pages HTML ; l'extraction est opre,  la fois  partir du contenu textuel de la page, qu' partir des balises HTML prsentes dans le code source.
Ligne de commande : un argument obligatoire (le fichier  analyser), et un argument facultatif (le fichier rsultats, par dfaut "decanteur_fichier.html.txt").
C:\>perl decanteur.pl <EventuellementFichierSource.html>

Format d'entre : n'importe quel format (de prfrence HTML).
 <meta name="author" content="Cyril Grouin">
 <a href="http://www.multimania.com/grouin">Mon site perso.</a><br><br>

Format de sortie :
 <auteur>Cyril Grouin</auteur>
 <lien>http://www.multimania.com/grouin<type>Mon site perso.</type></lien>

Historique :
28/11/00 mel.pl extrait mels & tel
09/01/01 v1.0 extrait nom/prnom ds mtabalise, dfinit type lien du mailto, n'extrait q'une info du mme type par lgne, pb si info tape s/ 2 lignes ds source
12/01/01 extrait # ICQ & adresses postales, dfinit type lien pr les pteurs (txt vs. img), n'extrait d infos q'une lgne s/ 2
17/01/01 extrait infos s/ ttes les lgnes
19/01/01 dsambigusation # tel vs. # fax
20/01/01 pas assez prcis pr adr postales : trop de bruit
06/02/01 v1.1&1.2 patrons d'xtract en dbut de prog, qq xtract n'ont plus lieu (# ICQ)
20/02/01 v2.0 substitut d patrons s/ chq lgne : permet xtraire pls infos mme type s/ une mme ligne, pas d'extract des # ICQ & liens
23/02/01 v2.1 xtract d liens avec typage, & d villes
24/02/01 Fich "global.txt" qui mmorise ttes les ana. Affichage du momt de l'ana (JJ-MM-AAAA HH:MM:SS) s/ les fich d rsult. Extract correcte d villes.
27/02/01 v2.1 xtract d SIRET. v2.2 : choix format de sortie : -txt (p df) vs. -html
02/03/01 Fichier rsultats = Fichier source + xtens ".decanteur"
03/03/01 xtract d adr postales, d btes postales & d liens avec indicat de chargemt. indice de progress d extract. 1 beep ds q 10 extract ont t effectues. script TransposeurFormatHtml.pl ralis.
07/03/01 # de vers du script ds fich global, rsultats placs ds ss dossier Sorties/
         v2.3 si aucun fichier spcifi en argumt, ana de ts les fich HTML du dossier. rel indice de progression. calcul de la dure de l'analyse.
09/03/01 v2.31 Fichier de statistiques.
23/03/01 xtract correcte d liens : arrt ds q </a> grce "?"
         <a href="http://.+"[^>]*>.+?</a>
30/03/01 prise en compte "#" dans les liens. pas xtract lien avec target
         rduct du bruit pr les villes, xtract nom gnrateur page web
22/04/01 ajout de dcimales aux pourcentages du fichier de stats
15/05/01 fich stat indiq nb d'infos pr chq cat en + du %

A faire :
_ dfinir le type de chaque extraction pr mel
_ prendre en compte le cas o l'utilisateur choisit le fichier

Bugs et problmes :
_ n'extrait pas le prfixe international du # de tlphone (+33)
_ confusion entre # de tel avec lettres et villes : <tel>20296 BIGUGL</tel> au lieu de <ville>20296 BIGUGLIA</ville>
_ n'extrait pas les # ICQ
_ liens avec cochonneries : 
 (caractre de retour  la ligne)

Infos :
_ http://grouin.free.fr/maitrise/memoire/scripts/

DOC


# Patrons d'extraction
$Pseudonyme="[A-Za-z0-9\-\_\.]+";
$Hebergeur="[A-Za-z0-9\-\_\.]+[.]{1}?[a-z]{2,3}";
$TelephoneParCouples="[\(]?[\+]?[0-9]{0,4}[\)]?[\s]?[\(]?0[\)]?[1-68][\-\/\. ]?[0-9]{2}?[\-\/\. ]?[0-9]{2}?[\-\/\. ]?[0-9]{2}?[\-\/\. ]?[0-9]{2}?";
$TelephoneParTriplets="[\(]?[\+]?[0-9]{0,4}[\)]?[\s]?[\(]?0[\)]?[\-\/\. ]?[1-68][\-\/\. ]?[0-9]{2}?[\-\/\. ]?[0-9A-Z]{3}?[\-\/\. ]?[0-9A-Z]{3}?";
$MetaNameAuthor="<(m|M)(eta|ETA) (n|N)(ame|AME)=[\"]?author[\"]? (c|C)(ontent|ONTENT)=[\"]?([^>\"]+)[\"]?>";
$MetaNameGenerator="<(m|M)(eta|ETA) (n|N)(ame|AME)=[\"]?(generator|GENERATOR)[\"]? (c|C)(ontent|ONTENT)=[\"]?([^>\"]+)[\"]?>";
$NumeroIcq="ICQ[\s]?[UIN\:\#]{0,4}[\s]?([0-9]{8,8})";
$NumeroSiret="SIRET[ ]?[:]? ([0-9 ]+)";
$NumeroApe="APE ([0-9]{3}?[ ]?[A-Z])";
$NumeroRue="([0-9]{1,4}(a|A|b|B|bis|ter|))[.,]?";
$NomRue="(av|av.|ave|avenue|bd|bd.|bvd|boulevard|chemin|esplanade|imp|imp.|impasse|lieudit|mail|pass.|passage|place|q.|quai|r|r.|rue|ruelle|sente|sentier) [^,.<>-]+";
$BoitePostale="(BP|B.P.) [0-9]+";
$CodePostal="[BF]?(-|)( |)[0-9]{5}?";
$NomVille="[A-Z][^<>.,;=\"\(\)\&\%\_]*";
$DebutLien="<(a|A) (href|HREF)=\"";
$Lien="(http:\/\/|ftp:\/\/|)[A-Za-z0-9&?\-\_\/\.\#\e]+";
$PostLien="[^>]*?>";
$Type=".+?";
$FinLien="<\/(a|A)>";


# Message d'aide
$MessageDAide="Ligne de commande :\nC:\>perl decanteur2.3.pl <Nom du seul fichier HTML a analyser>\nC:\>perl decanteur2.3.pl <rien> : permet d'analyser tous les fichiers HTML prsents dans le dossier.\n";
if ($ARGV[0] eq "-help") {
 die $MessageDAide;
}

# Rfrence de la progression de l'analyse
print "Indice de progression de l'analyse :\n\n  0          25           50          75         100 %\n  ";
# Moment du dbut de l'analyse en secondes
($H,$M,$S)=(localtime)[2,1,0];
$Depart=$H*3600 + $M*60 + $S;

# Ouverture du fichier  analyser
if ($ARGV[0] ne "") {
 $Source=$ARGV[0];
 &Analyse();
}
else {
 # Calcul du nombre total de fichiers  analyser
 while (($Next=<*.html>) | ($Next=<*.htm>)) { $NombreTotalDePages++; }
 # Analyse de tous les fichiers
 while (($Next=<*.html>) | ($Next=<*.htm>)) {
  $Source=$Next;
  open(Entree,"<$Source");
  # Numro de l'analyse en cours
  $NumeroDExtraction++;
  # Indice de Progression de la transposition
  $Deja++;
  $AncienPourcentage=$Pourcentage;
  $Pourcentage=int(($Deja*100/$NombreTotalDePages)/2);
  if ($Pourcentage != $AncienPourcentage) { print""; }
  if ($Pourcentage==50 && !$AEcrire) {
   $AEcrire=false;
   # Moment de la fin de l'analyse en secondes
   ($H,$M,$S)=(localtime)[2,1,0];
   $Arrivee=$H*3600 + $M*60 + $S;
   # Appel des statistiques de l'analyse
   &Statistiques();
  }

# Nom du fichier des rsultats
mkdir("Sorties",0777);
$Fichier="Sorties/" . $Source . ".decanteur";
open(Sortie,">$Fichier");
print Sortie "<source>$Source</source><date>" . (localtime) . "</date>\n\n";

# Ouverture du fichier global des rsultats ds ss dossier Sorties/
open(Global,">>Sorties/global.decanteur");
print Global "----------------------------------------------------------------------\n<script>Le Dcanteur</script><version>2.3</version>\n<source>$Source</source><date>" . (localtime) . "</date>\n<stockage>$Fichier</stockage>\n\n";


# Substitutions des patrons  chaque ligne en plaant le rsultat dudit patron sur une nouvelle ligne
while ($Ligne=<Entree>) {
 $Ligne =~ s/($Pseudonyme)\@($Hebergeur)/\n<e-mail><pseudo>$1<\/pseudo><hebergeur>$2<\/hebergeur><\/e-mail>\n/g;
 $Ligne =~ s/($TelephoneParCouples)/\n<tel>$1<\/tel>\n/g;
 $Ligne =~ s/($TelephoneParTriplets)/\n<tel>$1<\/tel>\n/g;
 $Ligne =~ s/$MetaNameAuthor/\n<auteur>$7<\/auteur>\n/g;
# $Ligne =~ s/$MetaNameGenerator/\n<logiciel>$8<\/logiciel>\n/g;
 $Ligne =~ s/$NumeroIcq/\n<icq>$1<\/icq>\n/g;
 $Ligne =~ s/$NumeroSiret/\n<siret>$1<\/siret>\n/g;
 $Ligne =~ s/$NumeroApe/\n<ape>$1<\/ape>\n/g;
 $Ligne =~ s/$NumeroRue ($NomRue)/\n<rue><numero>$1<\/numero><nom>$3<\/nom><\/rue>\n/g;
 $Ligne =~ s/($BoitePostale)/\n<bp>$1<\/bp>\n/g;
 $Ligne =~ s/($CodePostal) ($NomVille)/\n<ville><code>$1<\/code><nom>$4<\/nom><\/ville>\n/g;
 $Ligne =~ s/$DebutLien($Lien)$PostLien($Type)$FinLien/\n<lien><chemin>$3<\/chemin><type>$5<\/type><\/lien>\n/g;



 # Impression des lignes qui ne contiennent que des balises
 @ListeElementsLigne=split(/\n/,$Ligne);
 foreach $Element(@ListeElementsLigne) {
#  if ($Element =~ /^<(e-mail|auteur|icq|siret|ape|adresse|rue|ville|lien)>.+<\/$1>$/) {
   if (($Element =~ /^<e-mail>.+<\/e-mail>$/) ||
      ($Element =~ /^<tel>.+<\/tel>$/) ||
      ($Element =~ /^<auteur>.+<\/auteur>$/) ||
      ($Element =~ /^<logiciel>.+<\/logiciel>$/) ||
      ($Element =~ /^<icq>.+<\/icq>$/) ||
      ($Element =~ /^<siret>.+<\/siret>$/) ||
      ($Element =~ /^<ape>.+<\/ape>$/) ||
      ($Element =~ /^<rue>.+<\/rue>$/) ||
      ($Element =~ /^<bp>.+<\/bp>$/) ||
      ($Element =~ /^<ville>.+<\/ville>$/) ||
      ($Element =~ /^<lien>.+<type>.+<\/type><\/lien>$/)) {
   $NombreTotalDExtractions++;
   print Sortie "$Element\n";
   print Global "$Element\n";
   if ($Element =~ /^<e-mail>.+<\/e-mail>$/) {$NombreDEMails++;}
   if ($Element =~ /^<tel>.+<\/tel>$/) {$NombreDeTelephones++;}
   if ($Element =~ /^<auteur>.+<\/auteur>$/) {$NombreDAuteurs++;}
   if ($Element =~ /^<icq>.+<\/icq>$/) {$NombreDIcq++;}
   if ($Element =~ /^<siret>.+<\/siret>$/) {$NombreDeSirets++;}
   if ($Element =~ /^<ape>.+<\/ape>$/) {$NombreDApe++;}
   if ($Element =~ /^<rue>.+<\/rue>$/) {$NombreDeRues++;}
   if ($Element =~ /^<bp>.+<\/bp>$/) {$NombreDeBp++;}
   if ($Element =~ /^<ville>.+<\/ville>$/) {$NombreDeVilles++;}
   if ($Element =~ /^<lien>.+<type>.+<\/type><\/lien>$/) {$NombreDeLiens++;}
  }
 }
}


# Fermeture des fichiers
# &eacute; 
print Sortie "\n\nLe dcanteur 2.31 - 15\/05\/01\n Cyril Grouin, novembre 2000 - mai 2001.\nInfo : decanteur\@grouin.net";
close(Entree);
close(Sortie);
close(Global);
}
}


##### Routines #####

sub Statistiques {
 # Calcul de la dure totale de l'analyse
 $DureeDeLAnalyse=$Arrivee-$Depart;
 $DureeMoyenneParPage=$DureeDeLAnalyse/$NombreTotalDePages;
 print "\a\n  Dure: $DureeDeLAnalyse secondes pour $NombreTotalDePages pages\n"; 

 # Autres calculs
 $NombreMoyenDExtractionsParPage=int($NombreTotalDExtractions/$NombreTotalDePages);
 $PourcentageDeLiens=($NombreDeLiens*100/$NombreTotalDExtractions);
 $PourcentageDEMails=($NombreDEMails*100/$NombreTotalDExtractions);
 $PourcentageDeTelephones=($NombreDeTelephones*100/$NombreTotalDExtractions);
 $PourcentageDeRues=($NombreDeRues*100/$NombreTotalDExtractions);
 $PourcentageDeVilles=($NombreDeVilles*100/$NombreTotalDExtractions);
 $PourcentageDAuteurs=($NombreDAuteurs*100/$NombreTotalDExtractions);
 $PourcentageDeSirets=($NombreDeSirets*100/$NombreTotalDExtractions);
 $PourcentageDApe=($NombreDApe*100/$NombreTotalDExtractions);
 $PourcentageDIcq=($NombreDIcq*100/$NombreTotalDExtractions);
 $PourcentageDeBp=($NombreDeBp*100/$NombreTotalDExtractions);

 # Fichier de statistiques
 open(Stats,">Sorties/Statistiques.txt");
 print Stats (localtime) . "\n|\n|_ Corpus\n|  |_ $NombreTotalDePages pages\n|\n|_ Dure\n|  |_ Totale :           $DureeDeLAnalyse secondes\n";
 printf Stats "|  |_ Moyenne par page : %2.2f secondes\n",$DureeMoyenneParPage;
 print Stats "|\n|_ Nombre d'extractions\n|  |_ Total :            $NombreTotalDExtractions\n";
 printf Stats "|  |_ Moyenne par page : %3.1f\n|\n",$NombreMoyenDExtractionsParPage;
 print Stats "|_ Rpartition des extractions par lments\n";
 printf Stats "   |_ Liens :                  %2.2f % ($NombreDeLiens)\n",$PourcentageDeLiens;
 printf Stats "   |_ Adresses lectroniques : %2.2f % ($NombreDEMails)\n",$PourcentageDEMails;
 printf Stats "   |_ Tlphones :             %2.2f % ($NombreDeTelephones)\n",$PourcentageDeTelephones;
 printf Stats "   |_ Adresses postales :      %2.2f % ($NombreDeRues)\n",$PourcentageDeRues;
 printf Stats "   |_ Villes :                 %2.2f % ($NombreDeVilles)\n",$PourcentageDeVilles;
 printf Stats "   |_ Auteurs :                %2.2f % ($NombreDAuteurs)\n",$PourcentageDAuteurs;
 printf Stats "   |_ Numros SIRET :          %2.2f % ($NombreDeSirets)\n",$PourcentageDeSirets;
 printf Stats "   |_ Numros APE :            %2.2f % ($NombreDApe)\n",$PourcentageDApe;
 printf Stats "   |_ Numros ICQ :            %2.2f % ($NombreDIcq)\n",$PourcentageDIcq;
 printf Stats "   |_ Botes postales (BP) :   %2.2f % ($NombreDeBp)\n",$PourcentageDeBp;
 close(Stats);
}