#!/usr/bin/perl
# transposeur.pl

<<DOC;
Cyril Grouin - Wed Mar  7 15:56:37 2001

	transposeur.pl

Format d'entre : tous les fichiers rsultats fournis par Le Dcanteur prsents dans le mme dossier

Format de Sortie : fichier HTML prsentant les rsultats du dcanteur sous des couleurs diffrentes

A faire :

Bugs et problmes :

Infos :
_ http://grouin.free.fr/maitrise/memoire/scripts/

DOC

# Morphologies des sorties
$PoliceDeCaracteres="Verdana";
$TailleDeLaPolice="4";
$CouleurSource="#000080";
$CouleurDate="#000080";
$CouleurAuteur="#3333FF";
$CouleurLogiciel="#3333FF";
$CouleurEMail="#99FF99";
$CouleurLien="#009966";
$CouleurIcq="#44DDAA";
$CouleurTel="#FF9955";
$CouleurRue="#FF0000";
$CouleurVille="#FF0000";
$CouleurBp="#FF0000";
$CouleurSiret="#CC00CC";
$CouleurApe="#CC00CC";

# Fichier d'aide
$Help="Ligne de commande : perl TransposeurFormatHtml.pl\nCode couleurs pour le format HTML :\n1\/ References sur l'analyse : teintes bleues\n    _ source et date : bleu marine (\#000080)\n    _ auteur : bleu roi (\#3333FF)\n2\/ References electroniques : teintes vertes\n    _ e-mail : vert clair (\#99FF99)\n    _ icq : vert pomme (\#44DDAA)\n    _ lien : vert fonce (\#009966)\n3\/ References postales et telephoniques : teintes rouges\n    _ telephone et fax : orange (\#FF9955)\n    _ rue et ville : rouge (\#FF0000)\n4\/ Autres references : teintes violettes\n    _ siret et ape : violet (\#CC00CC)\n";
if ($ARGV[0] eq "-help") {
 die $Help;
}

# Rfrences de la progression
print "0  10   20   30   40   50   60   70   80   90  100 %\n";

# Ouverture du fichier d'entre : tous les fichiers d'extension ".decanteur" contenus dans le dossier
while ($Next=<*.decanteur>) { $NombreDeFichiers++; }
while ($Next=<*.decanteur>) {
 $FichierEntree=$Next;
 open(Entree,"<$FichierEntree");
 # Indice de Progression de la transposition
 $Deja++;
 $AncienPourcentage=$Pourcentage;
 $Pourcentage=int(($Deja*100/$NombreDeFichiers)/2);
 if ($Pourcentage != $AncienPourcentage) { print""; }

# Ouverture du fichier de sortie ds le ss dossier Sorties/
$Fichier=$FichierEntree . ".html";
open(Sortie,">$Fichier");
print Sortie "<html><body><font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"#000080\">$FichierEntree<\/font><br>\n";

# Transposition des rsultats du Dcanteur au format HTML
while ($Ligne = <Entree>) {
 if ($Ligne =~ /<source>(.+)<\/source>/) { print Sortie "____________________<br><font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurSource\">$1<\/font><br>\n"; } 
 if ($Ligne =~ /<date>(.+)<\/date>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurDate\">$1<\/font><br><br>\n"; } 
 if ($Ligne =~ /<auteur>(.+)<\/auteur>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurAuteur\">$1<\/font><br>\n"; }
 if ($Ligne =~ /<logiciel>(.+)<\/logiciel>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurLogiciel\">$1<\/font><br>\n"; }
 if ($Ligne =~ /<e-mail><pseudo>(.+)<\/pseudo><hebergeur>(.+)<\/hebergeur><\/e-mail>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurEMail\">$1\@$2<\/font><br>\n"; }
 if ($Ligne =~ /<lien><chemin>(.+)<\/chemin><type>(.+)<\/type><\/lien>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurLien\">$1 - ($2)<\/font><br>\n"; }
 if ($Ligne =~ /<icq>(.+)<\/icq>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurIcq\">$1<\/font><br>\n"; }
 if ($Ligne =~ /<tel>(.+)<\/tel>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurTel\">$1<\/font><br>\n"; }
 if ($Ligne =~ /<rue><numero>(.+)<\/numero><nom>(.+)<\/nom><\/rue>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurRue\">$1 $2<\/font><br>\n"; }
 if ($Ligne =~ /<bp>(.+)<\/bp>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurBp\">$1<\/font><br>\n"; }
 if ($Ligne =~ /<ville><code>(.+)<\/code><nom>(.+)<\/nom><\/ville>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurVille\">$1 $2<\/font><br>\n"; }
 if ($Ligne =~ /<siret>(.+)<\/siret>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurSiret\">$1<\/font><br>\n"; }
 if ($Ligne =~ /<ape>(.+)<\/ape>/) { print Sortie "<font face=\"$PoliceDeCaracteres\" size=$TailleDeLaPolice color=\"$CouleurApe\">$1<\/font><br>\n"; }
}

# Fermeture des fichiers
print Sortie "<br><font face=\"$PoliceDeCaracteres\" color=\"#000080\" size=$TailleDeLaPolice>Le Transposeur - 09/03/01<br> Cyril Grouin, novembre 2000 - mars 2001.<br>Info : <a href=\"mailto:decanteur\@grouin.net\">decanteur\@grouin.net<\/a><\/font><\/body><\/html>";
close(Entree);
close(Sortie);
}